{
Fraktly
--------
David Pila, pil032, L395

Naprogramovno v Borland Delphi 3.

Program umouje vykreslit Mandelbrotovu, Juliovu
a Newtonovu mnoinu.

Mandelbrotova rovnice:
f(z) = z * z + c     c ... pozice vykreslovanho bodu
z0 = 0                     v komplexn rovin

Juliova rovnice:
f(z) = z * z + c     c ... libovoln zvolen konstanta
z0 = pozici bodu v komplexn rovin

Newtonova rovnice:
f(z) = (2 * z^3 + 1) / 3 * z^2
}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, FileCtrl, ShellApi, ComCtrls, ToolWin, Buttons, ExtCtrls,
  Spin, Gauges;

const xMin = -2.5;
const xMax = 2.3;
const TNewt = 0.365;
const StartIteraci = 30;
const epsilon = 1e-10; //puvodne 1e-16

type TComplex = record
       re: double;
       im: double;
     end;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Konec1: TMenuItem;
    Npovda1: TMenuItem;
    Oprogramu1: TMenuItem;
    Jazyk: TMenuItem;
    DirectoryListBox1: TDirectoryListBox;
    Jazyk1: TMenuItem;
    Jazyk2: TMenuItem;
    Jazyk3: TMenuItem;
    Jazyk4: TMenuItem;
    Jazyk5: TMenuItem;
    Jazyk6: TMenuItem;
    Jazyk7: TMenuItem;
    Jazyk8: TMenuItem;
    Jazyk9: TMenuItem;
    Jazyk10: TMenuItem;
    N1: TMenuItem;
    Uloitjako1: TMenuItem;
    Uloit1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Otevt1: TMenuItem;
    ToolBar1: TToolBar;
    Nastaven1: TMenuItem;
    Bevel1: TBevel;
    ToolButton1: TToolButton;
    SpeedButton1: TSpeedButton;
    ToolButton2: TToolButton;
    SpeedButton2: TSpeedButton;
    UloitjakoBMP1: TMenuItem;
    ToolButton3: TToolButton;
    SpeedButton3: TSpeedButton;
    SaveDialog2: TSaveDialog;
    StatusBar1: TStatusBar;
    GroupBox1: TGroupBox;
    RadioButton2: TRadioButton;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    SpinEdit1: TSpinEdit;
    ToolButton4: TToolButton;
    SpeedButton4: TSpeedButton;
    RadioButton1: TRadioButton;
    Label5: TLabel;
    GroupBox4: TGroupBox;
    Edit5: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    Edit6: TEdit;
    Pocitat1: TMenuItem;
    N2: TMenuItem;
    Bevel2: TBevel;
    RadioButton3: TRadioButton;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    OpenDialog1: TOpenDialog;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Image1: TImage;
    Pkazy1: TMenuItem;
    Vpoet1: TMenuItem;
    Pvodn1: TMenuItem;
    ToolButton5: TToolButton;
    SpeedButton5: TSpeedButton;
    ToolButton7: TToolButton;
    SpeedButton7: TSpeedButton;
    ToolButton8: TToolButton;
    SpeedButton8: TSpeedButton;
    N3: TMenuItem;
    Zoom2: TMenuItem;
    SpeedButton6: TSpeedButton;
    ToolButton6: TToolButton;
    Zoom1: TMenuItem;
    Label15: TLabel;
    ToolButton9: TToolButton;
    SpeedButton9: TSpeedButton;
    GroupBox5: TGroupBox;
    Edit7: TEdit;
    Edit8: TEdit;
    Label16: TLabel;
    Label17: TLabel;
    GroupBox6: TGroupBox;
    Edit9: TEdit;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Zobrazit1: TMenuItem;
    Zobrazit: TMenuItem;
    Zobrazit2: TMenuItem;
    Gauge1: TGauge;
    ToolButton10: TToolButton;
    procedure Oprogramu1Click(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Jazyk1Click(Sender: TObject);
    procedure Jazyk2Click(Sender: TObject);
    procedure Jazyk3Click(Sender: TObject);
    procedure Jazyk4Click(Sender: TObject);
    procedure Jazyk5Click(Sender: TObject);
    procedure Jazyk6Click(Sender: TObject);
    procedure Jazyk7Click(Sender: TObject);
    procedure Jazyk8Click(Sender: TObject);
    procedure Jazyk9Click(Sender: TObject);
    procedure Jazyk10Click(Sender: TObject);
    procedure Uloitjako1Click(Sender: TObject);
    procedure UloitjakoBMP1Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure Pocitat1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure Uloit1Click(Sender: TObject);
    procedure Otevt1Click(Sender: TObject);
    procedure Label12MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Label12Click(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Edit5Exit(Sender: TObject);
    procedure Edit6Exit(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Vpoet1Click(Sender: TObject);
    procedure Pvodn1Click(Sender: TObject);
    procedure Zoom2Click(Sender: TObject);
    procedure Zoom1Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure Zobrazit1Click(Sender: TObject);
    procedure Zobrazit2Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
    odevrit,start: boolean;
    polejazyku: array [1..10] of String;
    XtoY: real;
    stredN, MinC,MaxC,z,z0,z1,z8,step: TComplex;
    JKonst: TComplex;    // konstanta pro Juliovu mnozinu
    pictxMax,pictyMax: integer;
    iters: integer;    //Iterace
    Bitmapa: TBitmap;
    Newt: real;
    Ulozit: String;
    MysDole: boolean;
    ZacBod, KonBod: TPoint;
    oldX, oldY: Integer;
    procedure OpenObject (p:PChar);
    procedure ZmenaReci (NazevSouboru:String);
    procedure NakresliObdelnik (TopLeft: TPoint; BottomRight: TPoint; AMode: TPenMode);
  public
    { Public declarations }
    procedure NastavPocatek;
    procedure PocitejM;
    procedure PocitejJ;
    procedure PocitejN;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses unit2;

procedure TForm1.Oprogramu1Click(Sender: TObject);
var about_soub, radek: string;
    soub: TextFile;
begin
  about_soub := DirectoryListBox1.Directory + '\About.txt';
  if FileExists(about_soub) then
    begin
      AssignFile (soub, about_soub);
      Reset (soub);
      Form2.ListBox1.Items.Clear;
      While not eof (soub) do
        begin
          readln (soub, radek);
          Form2.ListBox1.Items.Add (radek);
        end;
      CloseFile (soub);
      Form2.ShowModal;
    end
  else
    begin
      MessageDlg(Label15.Caption, mtError, [mbOk], 0);
      start := False;
    end;
end;

procedure TForm1.Konec1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.OpenObject (p:PChar);
begin
  ShellExecute(handle, NIL, p, NIL, NIL, SW_SHOWNORMAL);
end;

procedure TForm1.ZmenaReci (NazevSouboru:String);
var soubor: TextFile;
    c: Integer;
    nazev, popisek: String;
begin
  nazev := DirectoryListBox1.Directory + NazevSouboru;
  if FileExists(nazev) = False then
    begin
      MessageDlg('Soubor obsahujc jazyk neexistuje!!! Program bude ukonen.',mtError, [mbOk], 0);
      start := False;
      Close;
    end

  else
    begin
      AssignFile(soubor,nazev);
      Reset (soubor);
      While not eof(soubor) do
        begin
          ReadLn (soubor, c);
          ReadLn (soubor, popisek);
          case c of
            0: begin
                 Form1.Caption := popisek;
                 Application.Title := popisek;
               end;
            1: Soubor1.Caption := popisek;
            2: Konec1.Caption := popisek;
            3: Nastaven1.Caption := popisek;
            4: Jazyk.Caption := popisek;
            5: Npovda1.Caption := popisek;
            6: Oprogramu1.Caption := popisek;
            7: begin
                 Form2.Caption := popisek;
                 SpeedButton9.Hint := popisek;
               end;
            8: Uloit1.Caption := popisek;
            9: Uloitjako1.Caption := popisek;
            10: Otevt1.Caption := popisek;
            11: SaveDialog1.Title := popisek;
            12: begin
                  SpeedButton1.Hint := popisek;
                  OpenDialog1.Title := popisek;
                end;
            13: SpeedButton2.Hint := popisek;
            14: UloitjakoBMP1.Caption := popisek;
            15: begin
                  SpeedButton3.Hint := popisek;
                  SaveDialog2.Title := popisek;
                end;
            16: GroupBox1.Caption := popisek;
            17: RadioButton1.Caption := popisek;
            18: RadioButton2.Caption := popisek;
            19: GroupBox2.Caption := popisek;
            20: GroupBox3.Caption := popisek;
            21: Label1.Caption := popisek;
            22: Label2.Caption := popisek;
            23: Label3.Caption := popisek;
            24: Label4.Caption := popisek;
            25: SpeedButton4.Hint := popisek;
            26: Label5.Caption := popisek;
            27: GroupBox4.Caption := popisek;
            28: Pocitat1.Caption := popisek;
            29: RadioButton3.Caption := popisek;
            30: Label8.Caption := popisek;
            31: Label9.Caption := popisek;
            32: Label10.Caption := popisek;
            33: Label11.Caption := popisek;
            34: Label13.Caption := popisek;
            35: Label14.Caption := popisek;
            36: Pkazy1.Caption := popisek;
            37: Vpoet1.Caption := popisek;
            38: Pvodn1.Caption := popisek;
            39: SpeedButton5.Hint := popisek;
            40: SpeedButton8.Hint := popisek;
            41: begin
                  Zoom1.Caption := popisek;
                  SpeedButton6.Hint := popisek;
                end;
            42: begin
                  Zoom2.Caption := popisek;
                  SpeedButton7.Hint := popisek;
                end;
            43: Label15.Caption := popisek;
            44: GroupBox5.Caption := popisek;
            45: GroupBox6.Caption := popisek;
            46: Label18.Caption := popisek;
            47: Label19.Caption := popisek;
            48: Label20.Caption := popisek;
            49: Label21.Caption := popisek;
            50: Zobrazit1.Caption := popisek;
            51: Zobrazit2.Caption := popisek;
            52: Zobrazit.Caption := popisek;
          end;
        end;
      CloseFile (Soubor);
      StatusBar1.SimpleText := Label10.Caption;
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var soubor: TextFile;
    radek, nazev: String;
    defindex, index, i, pom: Integer;
    defjaz: boolean;
begin
  Bitmapa := TBitmap.Create;
  oldX := Image1.Width;
  oldY := Image1.Height;
  index := 0;
  odevrit := False;
  Ulozit := '';
  defindex := 0;
  defjaz := True;
  i := 0;
  start := True;
  nazev := DirectoryListBox1.Directory + '\Fraktaly.ini';
  if FileExists(nazev) then
    begin
      AssignFile (soubor, nazev);
      Reset (soubor);
      While not eof (soubor) do
        begin
          Readln (soubor, radek);
          if radek = '[BeginLanguages]' then
            begin
              index := 1;
              i := 0;
              Continue;
            end;
          if radek = '[EndLanguages]' then
            begin
              index := 0;
              i := 0;
              Continue;
            end;
          case index of
            1: begin
                 i := i + 1;
                 pom := (i div 2) + (i mod 2);
                 case pom of
                   1: begin
                         if (i mod 2) = 1 then
                           Jazyk1.Caption := radek;
                         if (i mod 2) = 0 then
                           polejazyku[pom] := radek;
                         if (radek = '#NoLanguage') or (radek = '#NoFile') then
                           Jazyk1.Visible := False
                         else
                           Jazyk1.Visible := True;
                         if (Jazyk1.Visible)and(defjaz) then
                           begin
                             Jazyk1.Checked := True;
                             defjaz := False;
                             defindex := 1;
                           end;
                       end;
                   2: begin
                         if (i mod 2) = 1 then
                           Jazyk2.Caption := radek;
                         if (i mod 2) = 0 then
                           polejazyku[pom] := radek;
                         if (radek = '#NoLanguage') or (radek = '#NoFile') then
                           Jazyk2.Visible := False
                         else
                           Jazyk2.Visible := True;
                         if (Jazyk2.Visible)and(defjaz) then
                           begin
                             Jazyk2.Checked := True;
                             defjaz := False;
                             defindex := 2;
                           end;
                       end;
                   3: begin
                         if (i mod 2) = 1 then
                           Jazyk3.Caption := radek;
                         if (i mod 2) = 0 then
                           polejazyku[pom] := radek;
                         if (radek = '#NoLanguage') or (radek = '#NoFile') then
                           Jazyk3.Visible := False
                         else
                           Jazyk3.Visible := True;
                         if (Jazyk3.Visible)and(defjaz) then
                           begin
                             Jazyk3.Checked := True;
                             defjaz := False;
                             defindex := 3;
                           end;
                       end;
                   4: begin
                         if (i mod 2) = 1 then
                           Jazyk4.Caption := radek;
                         if (i mod 2) = 0 then
                           polejazyku[pom] := radek;
                         if (radek = '#NoLanguage') or (radek = '#NoFile') then
                           Jazyk4.Visible := False
                         else
                           Jazyk4.Visible := True;
                         if (Jazyk4.Visible)and(defjaz) then
                           begin
                             Jazyk4.Checked := True;
                             defjaz := False;
                             defindex := 4;
                           end;
                       end;
                   5: begin
                         if (i mod 2) = 1 then
                           Jazyk5.Caption := radek;
                         if (i mod 2) = 0 then
                           polejazyku[pom] := radek;
                         if (radek = '#NoLanguage') or (radek = '#NoFile') then
                           Jazyk5.Visible := False
                         else
                           Jazyk5.Visible := True;
                         if (Jazyk5.Visible)and(defjaz) then
                           begin
                             Jazyk5.Checked := True;
                             defjaz := False;
                             defindex := 5;
                           end;
                       end;
                   6: begin
                         if (i mod 2) = 1 then
                           Jazyk6.Caption := radek;
                         if (i mod 2) = 0 then
                           polejazyku[pom] := radek;
                         if (radek = '#NoLanguage') or (radek = '#NoFile') then
                           Jazyk6.Visible := False
                         else
                           Jazyk6.Visible := True;
                         if (Jazyk6.Visible)and(defjaz) then
                           begin
                             Jazyk6.Checked := True;
                             defjaz := False;
                             defindex := 6;
                           end;
                       end;
                   7: begin
                         if (i mod 2) = 1 then
                           Jazyk7.Caption := radek;
                         if (i mod 2) = 0 then
                           polejazyku[pom] := radek;
                         if (radek = '#NoLanguage') or (radek = '#NoFile') then
                           Jazyk7.Visible := False
                         else
                           Jazyk7.Visible := True;
                         if (Jazyk7.Visible)and(defjaz) then
                           begin
                             Jazyk7.Checked := True;
                             defjaz := False;
                             defindex := 7;
                           end;
                       end;
                   8: begin
                         if (i mod 2) = 1 then
                           Jazyk8.Caption := radek;
                         if (i mod 2) = 0 then
                           polejazyku[pom] := radek;
                         if (radek = '#NoLanguage') or (radek = '#NoFile') then
                           Jazyk8.Visible := False
                         else
                           Jazyk8.Visible := True;
                         if (Jazyk8.Visible)and(defjaz) then
                           begin
                             Jazyk8.Checked := True;
                             defjaz := False;
                             defindex := 8;
                           end;
                       end;
                   9: begin
                         if (i mod 2) = 1 then
                           Jazyk9.Caption := radek;
                         if (i mod 2) = 0 then
                           polejazyku[pom] := radek;
                         if (radek = '#NoLanguage') or (radek = '#NoFile') then
                           Jazyk9.Visible := False
                         else
                           Jazyk9.Visible := True;
                         if (Jazyk9.Visible)and(defjaz) then
                           begin
                             Jazyk9.Checked := True;
                             defjaz := False;
                             defindex := 9;
                           end;
                       end;
                   10: begin
                         if (i mod 2) = 1 then
                           Jazyk10.Caption := radek;
                         if (i mod 2) = 0 then
                           polejazyku[pom] := radek;
                         if (radek = '#NoLanguage') or (radek = '#NoFile') then
                           Jazyk10.Visible := False
                         else
                           Jazyk10.Visible := True;
                         if (Jazyk10.Visible)and(defjaz) then
                           begin
                             Jazyk10.Checked := True;
                             defjaz := False;
                             defindex := 10;
                           end;
                       end;
                   end;
               end;
            end;
        end;
      if defindex <> 0 then
        ZmenaReci (polejazyku[defindex])
      else
        begin
          MessageDlg('Nen definovn dn jazyk!!! Program bude ukonen.',mtError, [mbOk], 0);
          start := False;
        end;
    end
  else
    begin
      MessageDlg('Incializacni soubor "Fraktaly.ini" neexistuje!!! Program bude ukonen.',mtError, [mbOk], 0);
      start := False;
    end;
  NastavPocatek;
//  SpeedButton4Click(Sender);
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  if not start then
    Close;
end;

procedure TForm1.Jazyk1Click(Sender: TObject);
begin
  Jazyk1.Checked := True;
  Jazyk2.Checked := False;
  Jazyk3.Checked := False;
  Jazyk4.Checked := False;
  Jazyk5.Checked := False;
  Jazyk6.Checked := False;
  Jazyk7.Checked := False;
  Jazyk8.Checked := False;
  Jazyk9.Checked := False;
  Jazyk10.Checked := False;
  ZmenaReci (polejazyku[1]);
end;

procedure TForm1.Jazyk2Click(Sender: TObject);
begin
  Jazyk2.Checked := True;
  Jazyk1.Checked := False;
  Jazyk3.Checked := False;
  Jazyk4.Checked := False;
  Jazyk5.Checked := False;
  Jazyk6.Checked := False;
  Jazyk7.Checked := False;
  Jazyk8.Checked := False;
  Jazyk9.Checked := False;
  Jazyk10.Checked := False;
  ZmenaReci (polejazyku[2]);
end;

procedure TForm1.Jazyk3Click(Sender: TObject);
begin
  Jazyk3.Checked := True;
  Jazyk2.Checked := False;
  Jazyk1.Checked := False;
  Jazyk4.Checked := False;
  Jazyk5.Checked := False;
  Jazyk6.Checked := False;
  Jazyk7.Checked := False;
  Jazyk8.Checked := False;
  Jazyk9.Checked := False;
  Jazyk10.Checked := False;
  ZmenaReci (polejazyku[3]);
end;

procedure TForm1.Jazyk4Click(Sender: TObject);
begin
  Jazyk4.Checked := True;
  Jazyk2.Checked := False;
  Jazyk3.Checked := False;
  Jazyk1.Checked := False;
  Jazyk5.Checked := False;
  Jazyk6.Checked := False;
  Jazyk7.Checked := False;
  Jazyk8.Checked := False;
  Jazyk9.Checked := False;
  Jazyk10.Checked := False;
  ZmenaReci (polejazyku[4]);
end;

procedure TForm1.Jazyk5Click(Sender: TObject);
begin
  Jazyk5.Checked := True;
  Jazyk2.Checked := False;
  Jazyk3.Checked := False;
  Jazyk4.Checked := False;
  Jazyk1.Checked := False;
  Jazyk6.Checked := False;
  Jazyk7.Checked := False;
  Jazyk8.Checked := False;
  Jazyk9.Checked := False;
  Jazyk10.Checked := False;
  ZmenaReci (polejazyku[5]);
end;

procedure TForm1.Jazyk6Click(Sender: TObject);
begin
  Jazyk6.Checked := True;
  Jazyk2.Checked := False;
  Jazyk3.Checked := False;
  Jazyk4.Checked := False;
  Jazyk5.Checked := False;
  Jazyk1.Checked := False;
  Jazyk7.Checked := False;
  Jazyk8.Checked := False;
  Jazyk9.Checked := False;
  Jazyk10.Checked := False;
  ZmenaReci (polejazyku[6]);
end;

procedure TForm1.Jazyk7Click(Sender: TObject);
begin
  Jazyk7.Checked := True;
  Jazyk2.Checked := False;
  Jazyk3.Checked := False;
  Jazyk4.Checked := False;
  Jazyk5.Checked := False;
  Jazyk6.Checked := False;
  Jazyk1.Checked := False;
  Jazyk8.Checked := False;
  Jazyk9.Checked := False;
  Jazyk10.Checked := False;
  ZmenaReci (polejazyku[7]);
end;

procedure TForm1.Jazyk8Click(Sender: TObject);
begin
  Jazyk8.Checked := True;
  Jazyk2.Checked := False;
  Jazyk3.Checked := False;
  Jazyk4.Checked := False;
  Jazyk5.Checked := False;
  Jazyk6.Checked := False;
  Jazyk7.Checked := False;
  Jazyk1.Checked := False;
  Jazyk9.Checked := False;
  Jazyk10.Checked := False;
  ZmenaReci (polejazyku[8]);
end;

procedure TForm1.Jazyk9Click(Sender: TObject);
begin
  Jazyk9.Checked := True;
  Jazyk2.Checked := False;
  Jazyk3.Checked := False;
  Jazyk4.Checked := False;
  Jazyk5.Checked := False;
  Jazyk6.Checked := False;
  Jazyk7.Checked := False;
  Jazyk8.Checked := False;
  Jazyk1.Checked := False;
  Jazyk10.Checked := False;
  ZmenaReci (polejazyku[9]);
end;

procedure TForm1.Jazyk10Click(Sender: TObject);
begin
  Jazyk10.Checked := True;
  Jazyk2.Checked := False;
  Jazyk3.Checked := False;
  Jazyk4.Checked := False;
  Jazyk5.Checked := False;
  Jazyk6.Checked := False;
  Jazyk7.Checked := False;
  Jazyk8.Checked := False;
  Jazyk9.Checked := False;
  Jazyk1.Checked := False;
  ZmenaReci (polejazyku[10]);
end;

procedure TForm1.Uloitjako1Click(Sender: TObject);
begin
  if SaveDialog1.Execute then
    begin
      Ulozit := SaveDialog1.FileName;
      Uloit1Click (Sender);
    end;
end;

procedure TForm1.UloitjakoBMP1Click(Sender: TObject);
begin
  if SaveDialog2.Execute then
    begin
      Image1.Picture.SaveToFile (SaveDialog2.Filename);
      StatusBar1.SimpleText := Label8.Caption + ' "' + SaveDialog2.FileName + '" ' + Label9.Caption;
    end;
end;

{ Nastaveni pocatecnich hodnot }
procedure TForm1.NastavPocatek;
begin
  XtoY := Image1.Width/Image1.Height;  //pomer sirky obrazku ku vysce
  if (Image1.Width <= Image1.Height) then
    Newt := Image1.Width * TNewt
  else
    Newt := Image1.Height * TNewt;
  MinC.re := 0;
  MinC.im := 0;
  MaxC := MinC;
  z :=  MinC;
  z0 := MinC;
  z1 := MinC;
  z8 := MinC;
  step := MinC;
  JKonst.re := 0;
  JKonst.im := -0.76;
  SpinEdit1.Value := StartIteraci;
  MinC.re := xMin;
  MinC.im := -(xMax-xMin)/(2*XtoY);
  MaxC.re := xMax;
  MaxC.im := -(MinC.im);
  Edit1.Text := FloatToStr(MinC.re);
  Edit2.Text := FloatToStr(MaxC.re);
  Edit3.Text := FloatToStr(MinC.im);
  Edit4.Text := FloatToStr(MaxC.im);
  Edit5.Text := FloatToStr(JKonst.re);
  Edit6.Text := FloatToStr(JKonst.im);
  iters := StartIteraci;
  pictxMax := Image1.Width;
  pictyMax := Image1.Height;
  Bitmapa.Width := Image1.Width;
  Bitmapa.Height := Image1.Height;
  stredN.re := pictxMax / 2;
  stredN.im := pictyMax / 2;
  Edit7.Text := FloatToStr (stredN.re);
  Edit8.Text := FloatToStr (stredN.im);
  Edit9.Text := FloatToStr (Newt);
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
  iters := SpinEdit1.Value;
  MinC.re := StrToFloat(Edit1.Text);
  MinC.im := StrToFloat(Edit3.Text);
  MaxC.re := StrToFloat(Edit2.Text);
  MaxC.im := StrToFloat(Edit4.Text);
  JKonst.re := StrToFloat(Edit5.Text);
  JKonst.im := StrToFloat(Edit6.Text);
  stredN.re := StrToFloat (Edit7.Text);
  stredN.im := StrToFloat (Edit8.Text);
  Newt := StrToFloat (Edit9.Text);
  if (RadioButton1.Checked) then
    PocitejM;
  if (RadioButton2.Checked) then
    PocitejJ;
  if (RadioButton3.Checked) then
    PocitejN;
end;

{ Vypocet Mandelbrotovy mnoziny }
procedure TForm1.PocitejM;
var i,j,itr,proc: integer;
    col: TColor;
begin
  StatusBar1.SimpleText := '';
  z.re := MinC.re;
  z.im := MaxC.im;
  step.re := ((MaxC.re - MinC.re)/pictxMax);
  step.im := ((MaxC.im - MinC.im)/pictyMax);
  for i := 0 to pictxMax do
    begin
      for j := 0 to pictyMax do
        begin
          z8.re := 0;
          z8.im := 0;
          itr := 0;
          while ((itr < 8)and((z8.re*z8.re+z8.im*z8.im) <= 4)) do
            begin
              itr := itr + 1;
              z0.re := z8.re * z8.re - z8.im * z8.im + z.re;
              z0.im := 2 * z8.re *z8.im + z.im;
              z8.re := z0.re;
              z8.im := z0.im;
            end;
          if ((itr = 8)and((z8.re*z8.re+z8.im*z8.im) <=4 )) then
            begin
              while ((itr < iters)and((z8.re*z8.re+z8.im*z8.im) <=4 )) do
                begin
                  itr := itr + 8;
                  z0.re := z8.re * z8.re - z8.im * z8.im + z.re;
                  z0.im := 2 * z8.re * z8.im + z.im;
                  z8.re := z0.re * z0.re - z0.im * z0.im + z.re;
                  z8.im := 2 * z0.re * z0.im + z.im;
                  z1.re := z8.re * z8.re - z8.im * z8.im + z.re;
                  z1.im := 2 * z8.re * z8.im + z.im;
                  z8.re := z1.re * z1.re - z1.im * z1.im + z.re;
                  z8.im := 2 * z1.re * z1.im + z.im;
                  z1.re := z8.re * z8.re - z8.im * z8.im + z.re;
                  z1.im := 2 * z8.re * z8.im + z.im;
                  z8.re := z1.re * z1.re - z1.im * z1.im + z.re;
                  z8.im := 2 * z1.re * z1.im + z.im;
                  z1.re := z8.re * z8.re - z8.im * z8.im + z.re;
                  z1.im := 2 * z8.re * z8.im + z.im;
                  z8.re := z1.re * z1.re - z1.im * z1.im + z.re;
                  z8.im := 2 * z1.re * z1.im + z.im;
                end;
              if (itr >= iters) then
                col := clBlack
              else
                begin
                  itr := itr - 7;
                  z8.re := z0.re;
                  z8.im := z0.im;
                  while ((z8.re*z8.re+z8.im*z8.im) <= 4) do
                    begin
                      itr := itr + 1;
                      z0.re := z8.re * z8.re - z8.im * z8.im + z.re;
                      z0.im := 2 * z8.re * z8.im + z.im;
                      z8.re := z0.re;
                      z8.im := z0.im;
                    end;
                  col := $00F020FF - ((clRed - clBlack) div iters) * itr;
                end;
            end
          else
            col := $00F020FF - ((clRed - clBlack) div iters) * itr;
          Bitmapa.Canvas.Pixels [i,j] := col;
//          Image1.Canvas.Pixels [i,j] := col;
          z.re := z.re;
          z.im := z.im - step.im;
        end;
      z.re := z.re + step.re;
      z.im := MaxC.im;
      if ((i mod 10) = 0) then
        begin
          proc := 100 * i div pictxMax;
          StatusBar1.SimpleText := Label5.Caption + ' ' + IntToStr(proc) + '%' ;
          Gauge1.Progress := proc;
        end;
    end;
  Image1.Picture.Bitmap := Bitmapa;
  Image1.Refresh;
  StatusBar1.SimpleText := Label5.Caption + ' 100%';
  Gauge1.Progress := 100;
end;

{ Vypocet Julianovy mnoziny }
procedure TForm1.PocitejJ;
var i,j,itr,proc: Integer;
    col: TColor;
begin
  StatusBar1.SimpleText := '';
  z.re := MinC.re;
  z.im := MaxC.im;
  step.re := (MaxC.re - MinC.re) / pictxMax;
  step.im := (MaxC.im - MinC.im) / pictyMax;
  for i := 0 to pictxMax do
    begin
      for j := 0 to pictyMax do
        begin
          z8.re := z.re;
          z8.im := z.im;
          itr := 0;
          while ((itr < 8)and((z8.re*z8.re+z8.im*z8.im) <=4 )) do
            begin
              itr := itr + 1;
              z0.re := z8.re * z8.re - z8.im * z8.im + JKonst.re;
              z0.im := 2 * z8.re * z8.im + JKonst.im;
              z8.re := z0.re;
              z8.im := z0.im;
            end;
          if ((itr = 8)and((z8.re*z8.re+z8.im*z8.im) <=4 )) then
            begin
              while ((itr < iters)and((z8.re*z8.re+z8.im*z8.im) <=4 )) do
                begin
                  itr := itr + 8;
                  z0.re := z8.re * z8.re - z8.im * z8.im + JKonst.re;
                  z0.im := 2 * z8.re * z8.im + JKonst.im;
                  z8.re := z0.re * z0.re - z0.im * z0.im + JKonst.re;
                  z8.im := 2 * z0.re * z0.im + JKonst.im;
                  z1.re := z8.re * z8.re - z8.im * z8.im + JKonst.re;
                  z1.im := 2 * z8.re * z8.im + JKonst.im;
                  z8.re := z1.re * z1.re - z1.im * z1.im + JKonst.re;
                  z8.im := 2 * z1.re * z1.im + JKonst.im;
                  z1.re := z8.re * z8.re - z8.im * z8.im + JKonst.re;
                  z1.im := 2 * z8.re * z8.im + JKonst.im;
                  z8.re := z1.re * z1.re - z1.im * z1.im + JKonst.re;
                  z8.im := 2 * z1.re * z1.im + JKonst.im;
                  z1.re := z8.re * z8.re - z8.im * z8.im + JKonst.re;
                  z1.im := 2 * z8.re * z8.im + JKonst.im;
                  z8.re := z1.re * z1.re - z1.im * z1.im + JKonst.re;
                  z8.im := 2 * z1.re * z1.im + JKonst.im;
                end;
              if (itr >= iters) then
                col := clBlack
              else
                begin
                  itr := itr - 7;
                  z8.re := z0.re;
                  z8.im := z0.im;
                  while ((z8.re*z8.re+z8.im*z8.im) <= 4 ) do
                    begin
                      itr := itr + 1;
                      z0.re := z8.re * z8.re - z8.im * z8.im + JKonst.re;
                      z0.im := 2 * z8.re * z8.im + JKonst.im;
                      z8.re := z0.re;
                      z8.im := z0.im;
                    end;
                  col := $00FF20FF - ((clRed-clBlack) div iters) * itr;
                end;
            end
          else
            col := $00FF20FF - ((clRed - clBlack) div iters) * itr;
//          Image1.Canvas.Pixels [i,j] := col;
          Bitmapa.Canvas.Pixels [i,j] := col;
          z.re := z.re;
          z.im := z.im - step.im;
        end;
      z.re := z.re + step.re;
      z.im := MaxC.im;
      if ((i mod 10) = 0) then
        begin
          proc := 100 * i div pictxMax;
          StatusBar1.SimpleText := Label5.Caption + ' ' + IntToStr(proc) + '%';
          Gauge1.Progress := proc;
        end;
    end;
  Image1.Picture.Bitmap := Bitmapa;
  Image1.Refresh;
  StatusBar1.SimpleText := Label5.Caption + ' 100%';
  Gauge1.Progress := 100;
end;


procedure TForm1.RadioButton1Click(Sender: TObject);
begin
  GroupBox4.Visible := False;
  GroupBox5.Visible := False;
  GroupBox6.Visible := False;  
  GroupBox3.Visible := True;
  Pvodn1.Enabled := True;
  if (Pocitat1.Checked)and(not odevrit) then
    Pvodn1Click (Sender);
end;

procedure TForm1.RadioButton2Click(Sender: TObject);
begin
  GroupBox4.Visible := True;
  GroupBox3.Visible := True;
  GroupBox5.Visible := False;
  GroupBox6.Visible := False;
  Pvodn1.Enabled := True;
  if (Pocitat1.Checked)and(not odevrit) then
    Pvodn1Click (Sender);
end;

procedure TForm1.Pocitat1Click(Sender: TObject);
begin
  if (Pocitat1.Checked) then
    Pocitat1.Checked := False
  else
    Pocitat1.Checked := True;
end;

procedure TForm1.FormResize(Sender: TObject);
var zvX, zvY: real;
begin
  ToolButton10.Width := Form1.ClientWidth - ToolButton10.Left - Gauge1.Width - 2;
  Label12.Left := Form1.ClientWidth - Label12.Width  - 4;
  if Statusbar1.Visible then
    begin
      Label12.Top := Form1.ClientHeight - Label12.Height - StatusBar1.Height - 5;
      Bevel2.Height := Form1.ClientHeight - Bevel2.Top - StatusBar1.Height - 5;
    end
  else
    begin
      Label12.Top := Form1.ClientHeight - Label12.Height - 5;
      Bevel2.Height := Form1.ClientHeight - Bevel2.Top - 5;
    end;
  Bevel1.Width := Form1.ClientWidth;
  GroupBox1.Left := Form1.ClientWidth - GroupBox1.Width - 5;
  GroupBox2.Left := Form1.ClientWidth - GroupBox2.Width - 5;
  GroupBox3.Left := Form1.ClientWidth - GroupBox3.Width - 5;
  GroupBox4.Left := Form1.ClientWidth - GroupBox4.Width - 5;
  GroupBox5.Left := Form1.ClientWidth - GroupBox5.Width - 5;
  GroupBox6.Left := Form1.ClientWidth - GroupBox6.Width - 5;
  Bevel2.Width := GroupBox1.Left - Bevel2.Left - 10;
  Image1.Width := Bevel2.Width - 4;
  Image1.Height := Bevel2.Height - 4;
  XtoY := Image1.Width/Image1.Height;  //pomer sirky obrazku ku vysce
  pictxMax := Image1.Width;
  pictyMax := Image1.Height;
  Bitmapa.Width := Image1.Width;
  Bitmapa.Height := Image1.Height;
  zvX := Image1.Width / oldX;
  zvY := Image1.Height / oldY;
  stredN.re := stredN.re  * zvX;
  stredN.im := stredN.im * zvY;
  if (Image1.Height <= Image1.Width) then
    Newt := zvY * Newt
  else
    Newt := zvX * Newt;
  Edit7.Text := FloatToStr(stredN.re);
  Edit8.Text := FloatToStr(stredN.im);
  Edit9.Text := FloatToStr (Newt);
  oldX := Image1.Width;
  oldY := Image1.Height;
  if start then
    SpeedButton4Click (Sender);
end;

procedure TForm1.PocitejN;
var n,i,j,proc: Integer;
    col: TColor;
    r1,r2,r3: TComplex;
    a,b,c,d,e,f: double;
    h: Byte;
begin
  col := clBlack;
  for j := 0 to pictyMax do
    for i := 0 to pictxMax do
      begin
        z.re := (i - (stredN.re)) / Newt;
        z.im := ((stredN.im) - j) / Newt;
        r1.re := 1;
        r1.im := 0;
        r2.re := -0.5;
        r2.im := sqrt(3) / 2;
        r3.re := -0.5;
        r3.im := -sqrt(3) / 2;
        h := 0;
        for n := 1 to iters do
          begin
            if ((z.re = 0)and(z.im = 0)) then
              begin
                z.re := 0;
                z.im := 0;
              end
            else
              begin
                a := z.re;
                b := z.im;
                c := 2 * (a * a * a - 3 * a * b * b) + 1;
                d := 2 * (- b * b * b + 3 * b * a * a);
                e := 3 * (a * a - b * b);
                f := 6 * a * b;
                z.re := (c * e + f * d) / (e * e + f * f);
                z.im := (d * e - c * f) / (e * e + f * f);
              end;
            if (sqrt((z.re-r1.re)*(z.re-r1.re)+(z.im-r1.im)*(z.im-r1.im)) < epsilon) then
              begin
                h := 1;
                col := 256 - (256 * n div iters);
                break;
              end;
            if (sqrt((z.re-r2.re)*(z.re-r2.re)+(z.im-r2.im)*(z.im-r2.im)) < epsilon) then
              begin
                h := 2;
                col := (256 - (256 * n div iters)) * 256;
                break;
              end;
            if (sqrt((z.re-r3.re)*(z.re-r3.re)+(z.im-r3.im)*(z.im-r3.im)) < epsilon) then
              begin
                h := 3;
                col := (256 - (256 * n div iters)) * 256*256;
                break;
              end;
          end;
        if h = 0 then
          col := clBlack;
//        Image1.Canvas.Pixels [i,j] := col;
        Bitmapa.Canvas.Pixels [i,j] := col;
        if ((j mod 10) = 0) then
          begin
            proc := 100 * j div pictyMax;
            StatusBar1.SimpleText := Label5.Caption + ' ' + IntToStr(proc) + '%';
            Gauge1.Progress := proc;
          end;
      end;
  Image1.Picture.Bitmap := Bitmapa;
  Image1.Refresh;
  StatusBar1.SimpleText := Label5.Caption + ' 100%';
  Gauge1.Progress := 100;
end;

procedure TForm1.RadioButton3Click(Sender: TObject);
begin
  GroupBox5.Visible := True;
  GroupBox6.Visible := True;
  GroupBox4.Visible := False;
  GroupBox3.Visible := False;
  Pvodn1.Enabled := False;
  Zoom1.Enabled := True;
  SpeedButton6.Enabled := True;
  if (Pocitat1.Checked)and(not odevrit) then
    Pvodn1Click (Sender);
end;

procedure TForm1.Uloit1Click(Sender: TObject);
var soubor: TextFile;
begin
  if Ulozit = '' then
    Uloitjako1Click(Sender)
  else
    begin
      AssignFile(soubor,Ulozit);
      Rewrite (soubor);
      Writeln (soubor, SpinEdit1.Value);
      Writeln (soubor, Edit5.Text);
      Writeln (soubor, Edit6.Text);
      Writeln (soubor, RadioButton1.Checked);
      Writeln (soubor, RadioButton2.Checked);
      Writeln (soubor, RadioButton3.Checked);
      Writeln (soubor, Edit1.Text);
      Writeln (soubor, Edit2.Text);
      Writeln (soubor, Edit3.Text);
      Writeln (soubor, Edit4.Text);
      Writeln (soubor, Edit7.Text);
      Writeln (soubor, Edit8.Text);
      Writeln (soubor, Edit9.Text);
      Writeln (soubor, oldX);
      Writeln (soubor, oldY);
      CloseFile (soubor);
      StatusBar1.SimpleText := Label8.Caption + ' "' + Ulozit + '" ' + Label9.Caption;
    end;
end;

procedure TForm1.Otevt1Click(Sender: TObject);
var soubor:TextFile;
    a: Integer;
    c: String;
begin
  if OpenDialog1.Execute then
    begin
      odevrit := True;
      AssignFile (soubor, OpenDialog1.FileName);
      Reset (soubor);
      Readln (soubor, a);
      SpinEdit1.Value := a;
      Readln (soubor, c);
      Edit5.Text := c;
      Readln (soubor, c);
      Edit6.Text := c;
      Readln (soubor, c);
      if c = 'TRUE' then
        RadioButton1.Checked := True
      else
        RadioButton1.Checked := False;
      Readln (soubor, c);
      if c = 'TRUE' then
        RadioButton2.Checked := True
      else
        RadioButton2.Checked := False;
      Readln (soubor, c);
      if c = 'TRUE' then
        RadioButton3.Checked := True
      else
        RadioButton3.Checked := False;
      Readln (soubor, c);
      Edit1.Text := c;
      Readln (soubor, c);
      Edit2.Text := c;
      Readln (soubor, c);
      Edit3.Text := c;
      Readln (soubor, c);
      Edit4.Text := c;
      Readln (soubor, c);
      Edit7.Text := c;
      Readln (soubor, c);
      Edit8.Text := c;
      Readln (soubor, c);
      Edit9.Text := c;
      Readln (soubor, a);
      oldX := a;
      Readln (soubor, a);
      oldY := a;
      CloseFile (soubor);
      StatusBar1.SimpleText := Label8.Caption + ' "' + OpenDialog1.FileName + '" ' + Label11.Caption;
      if pocitat1.Checked then
        SpeedButton4Click (Sender);
      odevrit := False;
    end;
end;

procedure TForm1.Label12MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Label12.Font.Color := clRed;
end;

procedure TForm1.Label12Click(Sender: TObject);
begin
  Label12.Font.Color := clBlue;
  OpenObject ('http://dejv.je.zde.cz');
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Label12.Font.Color := clBlue;
end;

procedure TForm1.Edit5Exit(Sender: TObject);
begin
  try
    StrToFloat (Edit5.Text);
  except
    on EConvertError do
      begin
        MessageDlg(Label13.Caption, mtError, [mbOk], 0);
        Edit5.Text := '0';
      end;
  end;
end;

procedure TForm1.Edit6Exit(Sender: TObject);
begin
  try
    StrToFloat (Edit6.Text);
  except
    on EConvertError do
      begin
        MessageDlg(Label13.Caption, mtError, [mbOk], 0);
        Edit6.Text := '0';
      end;
  end;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Label12.Font.Color := clBlue;
  if (MysDole){and((RadioButton1.Checked)or(RadioButton2.Checked))} then
    begin
      if (X < ZacBod.x) then
        X := ZacBod.x;
      if (Y < ZacBod.y) then
        Y := ZacBod.y;
      if (Y <> ZacBod.y) then
        begin
          if (XtoY <  (X - ZacBod.x) / (Y - ZacBod.y)) then
            Y := Round (((X - ZacBod.x) / XtoY) + ZacBod.y)
          else
            if (XtoY > (X - ZacBod.x) / (Y - ZacBod.y)) then
              X := Round ((XtoY * (Y - ZacBod.y)) + ZacBod.x);
        end;
      if (Y > Image1.Height) then
        begin
          Y := Image1.Height;
          X := Round ((XtoY * (Y - ZacBod.y)) + ZacBod.x);
        end;
      if (X > Image1.Width) then
        begin
          X := Image1.Width;
          Y := Round (((X - ZacBod.x) / XtoY) + ZacBod.y);
        end;
        NakresliObdelnik (ZacBod, KonBod, pmNotXor);
        KonBod := Point(X, Y);
        NakresliObdelnik (ZacBod, KonBod, pmNotXor);
    end;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   if (Button = mbLeft){and((RadioButton1.Checked)or(RadioButton2.Checked))} then
     begin
       MysDole := True;
       Image1.Canvas.MoveTo(X, Y);
       ZacBod := Point(X, Y);
       KonBod := ZacBod;
     end;
end;

procedure TForm1.NakresliObdelnik (TopLeft: TPoint; BottomRight: TPoint; AMode: TPenMode);
begin
  with Image1.Canvas do
    begin
      Pen.Color := clRed;
      Pen.Mode := AMode;
      Pen.Style := psDot;
      Brush.Style := bsClear;
      Rectangle (TopLeft.x, TopLeft.y, BottomRight.x, BottomRight.y);
    end;
end;


procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var NewMin, NewMax: TComplex;
    zv: real;
begin
  if (MysDole){and((RadioButton1.Checked)or(RadioButton2.Checked))} then
    begin
      X := KonBod.x;
      Y := KonBod.y;
      NakresliObdelnik (ZacBod, Point(X,Y), pmCopy);
      MysDole := False;
      if (((X - ZacBod.x) <= 1)or((Y - ZacBod.y) <= 1)) then
        begin
        end
      else
        begin
          if (RadioButton1.Checked)or(RadioButton2.Checked) then
            begin
              NewMin.re := MinC.re + (MaxC.re - MinC.re) * ZacBod.x / pictxMax;
              NewMin.im := MaxC.im - (MaxC.im - MinC.im) * Y / pictyMax;
              NewMax.re := MinC.re + (MaxC.re - MinC.re) * X / pictxMax;
              NewMax.im := MaxC.im - (MaxC.im - MinC.im) * ZacBod.y / pictyMax;
              MinC := NewMin;
              MaxC := NewMax;
              Edit1.Text := FloatToStr(MinC.re);
              Edit2.Text := FloatToStr(MaxC.re);
              Edit3.Text := FloatToStr(MinC.im);
              Edit4.Text := FloatToStr(MaxC.im);
            end;
          if RadioButton3.Checked then
            begin
              zv := pictxMax / (KonBod.x - ZacBod.x);
              stredN.re := (stredN.re - ZacBod.x) * zv;
              stredN.im := (stredN.im - ZacBod.y) * zv;
              Newt := zv * Newt;
              Edit7.Text := FloatToStr(stredN.re);
              Edit8.Text := FloatToStr(stredN.im);
              Edit9.Text := FloatToStr (Newt);
            end;
          SpeedButton4Click (Sender);
          StatusBar1.SimpleText := Label18.Caption;
        end;
    end;
end;


procedure TForm1.Vpoet1Click(Sender: TObject);
begin
  SpeedButton4Click (Sender);
end;

procedure TForm1.Pvodn1Click(Sender: TObject);
begin
  if (RadioButton1.Checked)or(RadioButton2.Checked) then
    begin
      MinC.re := xMin;
      MinC.im := - (xMax - xMin) / (2 * XtoY);
      MaxC.re := xMax;
      MaxC.im := - MinC.im;
      Edit1.Text := FloatToStr (MinC.re);
      Edit2.Text := FloatToStr (MaxC.re);
      Edit3.Text := FloatToStr (MinC.im);
      Edit4.Text := FloatToStr (MaxC.im);
      if (Pocitat1.Checked) then
        SpeedButton4Click (Sender);
    end;
  if (RadioButton3.Checked) then
    begin
      if Image1.Width < Image1.Height then
        Newt := Image1.Width * TNewt
      else
        Newt := Image1.Height * TNewt;
      stredN.re := pictxMax / 2;
      stredN.im := pictyMax / 2;
      Edit7.Text := FloatToStr(stredN.re);
      Edit8.Text := FloatToStr(stredN.im);
      Edit9.Text := FloatToStr (Newt);
      if (Pocitat1.Checked) then
        SpeedButton4Click (Sender);
    end;
end;

procedure TForm1.Zoom2Click(Sender: TObject);
var NewMin, NewMax: TComplex;
    zv, d1, d2: real;
begin
  if (RadioButton1.Checked)or(RadioButton2.Checked) then
    begin
      d1 := (MaxC.re + MinC.re) / 2 - (MaxC.re - MinC.re);
      d2 := (MaxC.re + MinC.re) / 2 + (MaxC.re - MinC.re);
      NewMin.re := d1;
      NewMin.im := (MaxC.im + MinC.im) / 2 - (d2 - d1) / (2 * XtoY);
      NewMax.re := d2;
      NewMax.im := (MaxC.im + MinC.im) / 2 + (d2 - d1) / (2 * XtoY);
      MinC := NewMin;
      MaxC := NewMax;
      Edit1.Text := FloatToStr(MinC.re);
      Edit2.Text := FloatToStr(MaxC.re);
      Edit3.Text := FloatToStr(MinC.im);
      Edit4.Text := FloatToStr(MaxC.im);
      if Pocitat1.Checked then
        SpeedButton4Click (Sender);
      StatusBar1.SimpleText := Label19.Caption;
    end;
  if (RadioButton3.Checked) then
    begin
      ZacBod.x := - 2 * Round (pictxMax / 4);
      ZacBod.y := - 2 * Round (pictyMax / 4);
      KonBod.x := Round ((pictxMax / 4) * 6);
      KonBod.y := Round ((pictyMax / 4) * 6);
      zv := pictxMax / (KonBod.x - ZacBod.x);
      stredN.re := (stredN.re - ZacBod.x) * zv;
      stredN.im := (stredN.im - ZacBod.y) * zv;
      Newt := zv * Newt;
      Edit7.Text := FloatToStr(stredN.re);
      Edit8.Text := FloatToStr(stredN.im);
      Edit9.Text := FloatToStr (Newt);
      if Pocitat1.Checked then
        SpeedButton4Click (Sender);
      StatusBar1.SimpleText := Label19.Caption;
    end;
end;

procedure TForm1.Zoom1Click(Sender: TObject);
var NewMin, NewMax: TComplex;
    X, Y: Integer;
    zv: real;
begin
  if (RadioButton1.Checked)or(RadioButton2.Checked) then
    begin
      ZacBod.x := Round (pictxMax / 4);
      ZacBod.y := Round (pictyMax / 4);
      X := Round ((pictxMax / 4) * 3);
      Y := Round ((pictyMax / 4) * 3);
      NewMin.re := MinC.re + (MaxC.re - MinC.re) * ZacBod.x / pictxMax;
      NewMin.im := MaxC.im - (MaxC.im - MinC.im) * Y / pictyMax;
      NewMax.re := MinC.re + (MaxC.re - MinC.re) * X / pictxMax;
      NewMax.im := MaxC.im - (MaxC.im - MinC.im) * ZacBod.y / pictyMax;
      MinC := NewMin;
      MaxC := NewMax;
      Edit1.Text := FloatToStr(MinC.re);
      Edit2.Text := FloatToStr(MaxC.re);
      Edit3.Text := FloatToStr(MinC.im);
      Edit4.Text := FloatToStr(MaxC.im);
      if Pocitat1.Checked then
        SpeedButton4Click (Sender);
      StatusBar1.SimpleText := Label18.Caption;
    end;
  if (RadioButton3.Checked) then
    begin
      ZacBod.x := Round (pictxMax / 4);
      ZacBod.y := Round (pictyMax / 4);
      KonBod.x := Round ((pictxMax / 4) * 3);
      KonBod.y := Round ((pictyMax / 4) * 3);
      zv := pictxMax / (KonBod.x - ZacBod.x);
      stredN.re := (stredN.re - ZacBod.x) * zv;
      stredN.im := (stredN.im - ZacBod.y) * zv;
      Newt := zv * Newt;
      Edit7.Text := FloatToStr(stredN.re);
      Edit8.Text := FloatToStr(stredN.im);
      Edit9.Text := FloatToStr (Newt);
      if Pocitat1.Checked then
        SpeedButton4Click (Sender);
      StatusBar1.SimpleText := Label18.Caption;
    end;
end;



procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
  Pvodn1Click (Sender);
  StatusBar1.SimpleText := Label21.Caption;
end;

procedure TForm1.Zobrazit1Click(Sender: TObject);
begin
  if Zobrazit1.Checked then
    begin
      Zobrazit1.Checked := False;
      ToolBar1.Visible := False;
      Bevel1.Top := Bevel1.Top - ToolBar1.Height;
      Bevel2.Top := Bevel2.Top - ToolBar1.Height;
      Image1.Top := Image1.Top - ToolBar1.Height;
      GroupBox1.Top := GroupBox1.Top - ToolBar1.Height;
      GroupBox2.Top := GroupBox2.Top - ToolBar1.Height;
      GroupBox3.Top := GroupBox3.Top - ToolBar1.Height;
      GroupBox4.Top := GroupBox4.Top - ToolBar1.Height;
      GroupBox5.Top := GroupBox5.Top - ToolBar1.Height;
      GroupBox6.Top := GroupBox6.Top - ToolBar1.Height;
      Bevel2.Height := Bevel2.Height + ToolBar1.Height;
      Image1.Height := Image1.Height + ToolBar1.Height;
      FormResize (Sender);
    end
  else
    begin
      Zobrazit1.Checked := True;
      ToolBar1.Visible := True;
      Bevel1.Top := Bevel1.Top + ToolBar1.Height;
      Bevel2.Top := Bevel2.Top + ToolBar1.Height;
      Image1.Top := Image1.Top + ToolBar1.Height;
      GroupBox1.Top := GroupBox1.Top + ToolBar1.Height;
      GroupBox2.Top := GroupBox2.Top + ToolBar1.Height;
      GroupBox3.Top := GroupBox3.Top + ToolBar1.Height;
      GroupBox4.Top := GroupBox4.Top + ToolBar1.Height;
      GroupBox5.Top := GroupBox5.Top + ToolBar1.Height;
      GroupBox6.Top := GroupBox6.Top + ToolBar1.Height;
      Bevel2.Height := Bevel2.Height - ToolBar1.Height;
      Image1.Height := Image1.Height - ToolBar1.Height;
      FormResize (Sender);
    end;
end;

procedure TForm1.Zobrazit2Click(Sender: TObject);
begin
  if Zobrazit2.Checked then
    begin
      Zobrazit2.Checked := False;
      StatusBar1.Visible := False;
      Bevel2.Height := Bevel2.Height + StatusBar1.Height;
      Image1.Height := Image1.Height + StatusBar1.Height;
      FormResize (Sender);
    end
  else
    begin
      Zobrazit2.Checked := True;
      StatusBar1.Visible := True;
      Bevel2.Height := Bevel2.Height - StatusBar1.Height;
      Image1.Height := Image1.Height - StatusBar1.Height;
      FormResize (Sender);
    end
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if start = False then
    CanClose := True
  else
    if MessageDlg(Label20.Caption, mtConfirmation, [mbYes, mbNo], 0) = mrYes then
      CanClose := True
    else
      CanClose := False;
end;

end.
